package dev.fyloz.colorrecipesexplorer

object Constants {
    object ControllerPaths {
        const val COMPANY = "/api/company"
        const val FILE = "/api/file"
        const val MATERIAL = "/api/material"
        const val MATERIAL_TYPE = "/api/materialtype"
        const val MIX = "/api/recipe/mix"
        const val RECIPE = "/api/recipe"
        const val TOUCH_UP_KIT = "/api/touchupkit"
    }

    object FilePaths {
        private const val PDF = "pdf"
        private const val IMAGES = "images"

        const val SIMDUT = "$PDF/simdut"
        const val TOUCH_UP_KITS = "$PDF/touchupkits"
        const val RECIPE_IMAGES = "$IMAGES/recipes"
    }

    object ModelNames {
        const val COMPANY = "Company"
        const val MATERIAL = "Material"
        const val MATERIAL_TYPE = "MaterialType"
        const val MIX = "Mix"
        const val MIX_MATERIAL = "MixMaterial"
        const val MIX_TYPE = "MixType"
        const val RECIPE = "Recipe"
        const val RECIPE_STEP = "RecipeStep"
        const val TOUCH_UP_KIT = "TouchUpKit"
    }

    object ValidationMessages {
        const val SIZE_GREATER_OR_EQUALS_ZERO = "Must be greater or equals to 0"
        const val SIZE_GREATER_OR_EQUALS_ONE = "Must be greater or equals to 1"
        const val RANGE_OUTSIDE_PERCENTS = "Must be between 0 and 100"
    }

    object ValidationRegexes {
        const val VALIDATION_COLOR_PATTERN = "^#([0-9a-f]{6})$"
    }
}