package dev.fyloz.colorrecipesexplorer.dtos

import dev.fyloz.colorrecipesexplorer.Constants
import javax.validation.constraints.Min

sealed interface MixQuantityDto : EntityDto {
    val quantity: Float
    val position: Int

    val materialType: MaterialTypeDto
    val name: String
}

data class MixMaterialDto(
    override val id: Long = 0L,

    val material: MaterialDto,

    override val quantity: Float,

    override val position: Int
) : MixQuantityDto {
    override val materialType: MaterialTypeDto
        get() = material.materialType

    override val name: String
        get() = material.name
}

data class MixMixTypeDto(
    override val id: Long,

    val mixType: MixTypeDto,

    override val quantity: Float,

    override val position: Int
) : MixQuantityDto {
    override val materialType: MaterialTypeDto
        get() = mixType.materialType

    override val name: String
        get() = mixType.name
}

data class MixQuantitySaveDto(
    override val id: Long = 0L,

    val materialId: Long,

    @field:Min(0, message = Constants.ValidationMessages.SIZE_GREATER_OR_EQUALS_ZERO)
    val quantity: Float,

    val position: Int,

    val isMixType: Boolean
) : EntityDto