package dev.fyloz.colorrecipesexplorer.model

import javax.persistence.*

@Entity
@Table(name = "mix")
data class Mix(
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    override val id: Long?,

    var location: String?,

    @Column(name = "recipe_id")
    val recipeId: Long,

    @ManyToOne
    @JoinColumn(name = "mix_type_id")
    val mixType: MixType,

    @OneToMany(cascade = [CascadeType.ALL], fetch = FetchType.EAGER, orphanRemoval = true)
    @JoinColumn(name = "mix_id")
    val mixMaterials: List<MixMaterial>
) : ModelEntity