package dev.fyloz.colorrecipesexplorer.model

/** Represents an entity, named differently to prevent conflicts with the JPA annotation. */
interface ModelEntity {
    val id: Long?
}

interface NamedModelEntity : ModelEntity {
    val name: String
}

interface EntityDto<out E> {
    /** Converts the dto to an actual entity. */
    fun toEntity(): E {
        throw UnsupportedOperationException()
    }
}