package dev.fyloz.colorrecipesexplorer.model.touchupkit

import dev.fyloz.colorrecipesexplorer.model.ModelEntity
import java.time.LocalDate
import javax.persistence.*

@Entity
@Table(name = "touch_up_kit")
data class TouchUpKit(
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    override val id: Long?,

    val project: String,

    val buggy: String,

    val company: String,

    val quantity: Int,

    @Column(name = "shipping_date")
    val shippingDate: LocalDate,

    @Column(name = "completion_date")
    val completionDate: LocalDate?,

    @Column(name = "finish")
    val finish: String,

    @Column(name = "material")
    val material: String,

    @OneToMany(cascade = [CascadeType.ALL], fetch = FetchType.EAGER, orphanRemoval = true)
    @JoinColumn(name = "touch_up_kit_id")
    val content: List<TouchUpKitProduct>
) : ModelEntity

@Entity
@Table(name = "touch_up_kit_product")
data class TouchUpKitProduct(
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    override val id: Long?,

    val name: String,

    val description: String?,

    val quantity: Float,

    val ready: Boolean
) : ModelEntity