package dev.fyloz.colorrecipesexplorer.repository

import dev.fyloz.colorrecipesexplorer.model.Mix
import dev.fyloz.colorrecipesexplorer.model.MixType
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Modifying
import org.springframework.data.jpa.repository.Query

interface MixRepository : JpaRepository<Mix, Long> {
    /** Finds all mixes with the mix type with the given [mixTypeId]. */
    fun findAllByMixTypeId(mixTypeId: Long): Collection<Mix>

    /** Updates the [location] of the [Mix] with the given [id]. */
    @Modifying
    @Query("UPDATE Mix m SET m.location = :location WHERE m.id = :id")
    fun updateLocationById(id: Long, location: String?)
}
